import socket, struct
import Actions, Logger

def osc_string(s) :
    n = (len(s)+1)%4
    if n : return s+'\0'*(5-n)
    else : return s+'\0'

def osc_command(url,*args):
    tag=","
    argstring=""
    for arg in args :
        if type(arg) is int:
            tag += 'i'
            argstring += struct.pack(">I",arg)
        elif type(arg) is str:
            tag += 's'
            argstring += osc_string(arg)
        else:
            raise RunstimeError, "Invalid OSC argument"
    return osc_string(url) + osc_string(tag) + argstring

class OSCSender(object):

    def __init__(self, host, port):
        self._sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        self._target = (host,port)

    def command(self, path, *args):
        if type(args[0]) in (tuple, list) : args = args[0]
        Logger.log('osc','osc://%s:%s%s %s'
                   % (self._target[0], self._target[1], path,
                      ' '.join(map(repr,args))))
        self._sock.sendto(osc_command(path, *args),self._target)
        

class Controller(object) :

    def __init__(self, host, port):
        self._sender = OSCSender(host,port)

    def hit(self, command, index=0):
        self._sender.command("/sl/%d/hit" % index, str(command))


class Command(Actions.Action):

    def __init__(self, name, controller, command):
        Actions.Action.__init__(self, name)
        self._controller = controller
        self._command = command

    def __call__(self, binding):
        self._controller.hit(self._command)
